package net.miginfocom.examples;

import net.miginfocom.swt.MigLayout;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;


public class pm {
	/**
	 * page structure
	 */
	static Composite skeleton;

	/**
	 * container for dinamic contents.
	 */
	static Composite container;

	final static String buttonName = "Change the view";
	public static void main(String[] args) {
		Display display = new Display();
		Shell shell = new Shell(display);

		// Structure page will have two pieces.
		skeleton = new Composite(shell, SWT.NONE);
		skeleton.setLayout(new MigLayout("wrap 2"));
		skeleton.setLayoutData("w 100%");

		// One of the pieces will be static on the left. Like a menu.
		Text menu = new Text(skeleton, SWT.CENTER);
		menu.setText("A menu goes here.....");
		menu.setLayoutData("w 200px, aligny top");
		//menu.setLayoutData("w 40%, aligny top");
		menu.pack();

		// The other piece will be dynamic on the right.
		container = new Composite(skeleton, SWT.NONE);
		container.setLayout(new MigLayout("wrap 1"));
		container.setLayoutData("w 60%, h 100%");

		Text intro = new Text(container, SWT.CENTER);
		intro.setText("This content is an intro....");
		intro.pack();

		// This button allows us to change the content. Normally I pushed the menu on the left.
		Button push = new Button(container, SWT.PUSH);
		push.setData("anything", new Object());
		push.setText(buttonName);
		push.addMouseListener(
				new MouseAdapter() {

					@Override
					public void mouseUp(MouseEvent e) {
						super.mouseUp(e);
						test();
					}

				}
				);
		push.pack();

		container.pack();
		skeleton.pack();
		shell.pack();
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
		display.dispose();
	}

	/**
	 * My dynamic content
	 */
	static int count = 0;
	static void test() {
		container.dispose();

		container = new Composite(skeleton, SWT.NONE);
		container.setLayout(new MigLayout("wrap 1"));
		container.setLayoutData("w 100%, h 100%");

		Text helloText = new Text(container, SWT.CENTER);
		count++;
		helloText.setText("button clicked " + count + " times.");
		helloText.pack();

		Button push = new Button(container, SWT.PUSH);
		push.setData("anything", new Object());
		push.setText(buttonName);
		push.addMouseListener(
				new MouseAdapter() {

					@Override
					public void mouseUp(MouseEvent e) {
						super.mouseUp(e);
						test();
					}

				}
				);
		push.pack();

		container.pack();
		skeleton.pack();
	}
}

